if(!dojo._hasResource["com.ibm.mm.builder.widget.MumMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.MumMenu"] = true;
/**
 * This is a customized dijit.Menu
 *
 * @author Marshall (shiwcsdl@cn.ibm.com)
 * @author Erik	(bizheng@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.widget.MumMenu");

dojo.require("com.ibm.mm.builder.widget.ShadowMenu");

dojo.declare("com.ibm.mm.builder.widget.MumMenu", com.ibm.mm.builder.widget.ShadowMenu, {

	counter:0,
	
	templateString: 
		'<table class="dijit remixMenu" waiRole="menu" dojoAttachEvent="onkeypress:_onKeyPress">' +
    		'<tbody class="dijitReset" dojoAttachPoint="containerNode"></tbody>' +
    	'</table>',

	postCreate: function() {
		this.inherited(arguments);
		if (this.targetNodeIds && this.targetNodeIds.length == 1) {
			var target = this.targetNodeIds[0];
			var targetid = target.id;
			if (targetid) {
				if (targetid.indexOf("_menu") != -1) {
					var widgetId = targetid.substr(0, targetid.length - 5);
					var widgetSpan = dojo.byId(widgetId);
					if (widgetSpan) {
						if (widgetSpan.getAttribute("visible") === "false") {
							// fix the wrong open position for context menu in NVA
							this.offset_x = 41;
							this.offset_y = dojo.isIE ? 0 : 8;
						}
					}
					var contextWidget = dijit.byId(widgetId + com.ibm.mm.builder.constant.dragHandler + "_editbar");
					if (contextWidget) {
						dojo.connect(this, "onBlur", contextWidget, "hide");
					}
				}
			}
		}
	},
	    
	_pubMenuEvent:function(){
		
	},
	
	resizeShadow:function(){
		//TODO: a temp fix for IE7 issue, need to find correct solution soon.
		var self = this;
		setTimeout(function(){
			if(self.shadow){
				self.shadow.resize();
				self.shadow.setDisabled(false);
			}
		}, (dojo.isIE===7?500:0));
	},
	
	onClose:function(){
		// counter is the temp for dojo menu call onClose twice every time.
		this.counter = this.counter + 1;
		this.inherited(arguments);
		if (this.counter == 2){
			this.counter = 0;
			var self = this;
			setTimeout(function(){
				self._pubMenuEvent();	
			}, 0);
		}
	},
    onBlur: function(){
			dijit.popup.close(this);	
	},
	onOpen: function(){
		try {
			this.inherited(arguments);
			var self = this;
			if (dojo.isIE !== 7) { return; }
			setTimeout(function(){
				if (self.parentMenu && self.parentMenu.shadow) {
					self.parentMenu.shadow.resize();
				}
			}, 250);
		} catch (e) {
			console.log(e);
		}
	}
});

dojo.declare("com.ibm.mm.builder.widget.MumMenuItem", dijit.MenuItem, {
    templateString: 
		'<tr class="dijitReset dijitMenuItem remixMenuItem" dojoAttachPoint="focusNode" waiRole="menuitem" tabIndex="-1" ' +
    		'dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover,ondijitclick:_onClick">' +
	    	'<td><div dojoAttachPoint="iconNode" class="dijitReset lotusDijitMenuItemIcon"></div></td>' +
			'<td tabIndex="-1" class="dijitReset dijitMenuItemLabel lotusDijitMenuItemLabel truncatedLabel" widthLimit="170" dojoAttachPoint="containerNode" waiRole="menuitem"></td>' +
			'<td class="dijitReset" dojoAttachPoint="arrowCell">' +
				'<div dojoAttachPoint="arrowWrapper" style="display: none">'+
				    '<div class="lotusDijitMenuExpandEnabled"></div>' +
				    '<span class="dijitMenuExpandA11y">+</span>' +
				'</div>'+
		    '</td>' +
			'<td><div class="dijitReset lotusDijitMenuItemIcon"></div></td>' +
    	'</tr>',
	postCreate: function(){
		if(dojo.isIE === 7 ){
			com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(this.containerNode, null, {fontSize:"1.3em"});
		}
	},
	
    focus: function(){
        dojo.addClass(this.domNode, 'dijitMenuItemHover');
		this.inherited(arguments);
    },

	_setSelected: function(selected){
		this.inherited(arguments);	
		if(selected){ return; }
		dojo.removeClass(this.domNode,"dijitMenuItemHover");
	},
	
	setDisabled: function(/*Boolean*/value){
        // summary: enable or disable this menu item
        this.disabled = value;
        dojo[value ? "addClass" : "removeClass"](this.domNode, 'remixMenuItemDisabled');
        dijit.setWaiState(this.containerNode, 'disabled', value ? 'true' : 'false');
    },
	
	startup: function(){
		if (this.popup) {
			dojo.body().appendChild(this.popup.domNode);
			this.arrowWrapper.style.display = "";
			this.popup.domNode.style.display = "none";
			dijit.setWaiState(this.containerNode, "haspopup", "true");
		}
	},
	
	destroyDescendants: function(){
		if(this.popup){
			this.popup.destroyRecursive();
			delete this.popup;
		}
		this.inherited(arguments);
	}
});

dojo.declare("com.ibm.mm.builder.widget.MumPopupMenuItem", com.ibm.mm.builder.widget.MumMenuItem, {
	
	_fillContent: function(){
		if(this.srcNodeRef){
			var nodes = dojo.query("*", this.srcNodeRef);
			dijit.PopupMenuItem.superclass._fillContent.call(this, nodes[0]);

			// save pointer to srcNode so we can grab the drop down widget after it's instantiated
			this.dropDownContainer = this.srcNodeRef;
		}
	},
		
	startup: function(){
		if(this._started){ return; }
		this.inherited(arguments);

		// we didn't copy the dropdown widget from the this.srcNodeRef, so it's in no-man's
		// land now.  move it to dojo.doc.body.
		if(!this.popup){
			var node = dojo.query("[widgetId]", this.dropDownContainer)[0];
			this.popup = dijit.byNode(node);
		}
		dojo.body().appendChild(this.popup.domNode);

		this.popup.domNode.style.display="none";
		if(this.arrowWrapper){
			dojo.style(this.arrowWrapper, "visibility", "");
		}
		dijit.setWaiState(this.focusNode, "haspopup", "true");
	},
	
	destroyDescendants: function(){
		if(this.popup){
			this.popup.destroyRecursive();
			delete this.popup;
		}
		this.inherited(arguments);
	}
	
});

dojo.declare("com.ibm.mm.builder.widget.MumMenuSeparator", dijit.MenuSeparator, {
    // summary
    //	A line between two menu items 
    templateString: 
		'<tr>'+
    		'<td colspan=4>'+
				'<div class="mumMenuSeparator"></div>'+
			'</td>' +
		'</tr>'
});

}
