if(!dojo._hasResource["com.ibm.utilities"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.utilities"] = true;
/*
 * @author Ben
 */ 
dojo.provide("com.ibm.utilities");

dojo.require("dojo.string");
dojo.require("com.ibm.domUtilities");

com.ibm.utilities = {
	urlToProxyUrl: function ( /*String*/ url, /*String?*/ proxyURI ) {
		var ret = proxyURI ? proxyURI : "/proxy";
		var protocol = "http";
		var colon = url.indexOf('://');
		if(colon > -1) {
			protocol = url.substring(0, colon);
			url = url.substring(colon + 3);
		}
		url = url.replace(/:/g, '%3A');
		
		return ret + '/' + protocol + '/' + url;
	},
	withBaseUrl: function(/*String*/ relativeUrl) {
		// summary: Rewrites a relative url to include the base url that's present in
		//		the href attribute of the first base tag found in the document if one exists.
		//		If one does not exist, this returns the relative url argument unchanged.
		//		This is useful for fixing relative URLs in a document that includes a base
		//		url while using IE as it does not include base url calculations when dynamically
		//		changing href or src attributes on elements, or when modifying window.location
		//		properties.
		// relativeUrl: String url relative to the current host to rewrite
		if (relativeUrl.charAt(0) == '/') {
			return relativeUrl;
		}
		return com.ibm.utilities.baseUrl() + relativeUrl;
	},
	baseUrl: function() {
		// summary: Returns the base url used in the document for any relative url
		//		resolution.  This is retrieved by looking up the base tag in the document
		//		and returning its href attribute if it exists.  Otherwise, it simply
		//		returns the empty string.
		if(!this._baseUrl) {
			var base = dojo.doc.getElementsByTagName("base")[0];
			if (base) {
				this._baseUrl = base.getAttribute("href");
			}
			if (!this._baseUrl) {
				this._baseUrl = "";
			}
		}
		return this._baseUrl;
	},
	stripUrlFragment: function(/*String*/url) {
		// summary: Strips the fragment identifier from a url if one exists, returning
		//		the new url without any fragment identifiers.
		// url: String url to strip fragment identifiers
		var h = url.indexOf("#");
		if (h > -1) {
			url = url.substr(0, h);
		}
		return url;
	},
	stripTrailingSlash: function(/*String*/url) {
		// summary: Strips trailing slashes from a url if any exist, returning
		//		the new url without a slash at the end.
		// url: String url to strip any trailing slashes from
		if(!url) {
			return "";
		}
		else {
			return url.replace(/\/+$/g, "");
		}
	},
	actionIO: function(/*String*/ url, /*String*/ method) {
		if(url) {
			var form = dojo.doc.createElement("form");
			form.setAttribute("action", url);
			if (method) {
				method = method.toLowerCase();
			}
			switch(method) {
				case "get":
					form.setAttribute("method", "GET");
					break;
				case "post":
				case "delete":
				case "put":
					form.setAttribute("method", "POST");
					break;
				default:
			}
			dojo.body().appendChild(form);
			form.submit();
		}
	},
	refreshPage: function(){
		var url, hash = -1, bases = document.getElementsByTagName('base');
		if (bases.length > 0) {
			url = bases[0].href; // use url from base tag
		}
		else { // use current location with any hash removed
			url = top.location.href;
			hash = url.indexOf('#');
			if (dojo.isSafari < 4 && hash > -1) { // nothing but location.reload works in 
				window.location.reload(); // Safari when there is a hash in the url
			}
			if (hash > -1) {
				url = url.substring(0, hash);
			}
		}
		window.location.assign(url);  // refresh without reloading static content
	}
};

(function(){
	// unique (arbitrary) boundary
	var boundary = "{EB2F8DA2-5B2C-F66A-CDD0-A2D42143F5AC}";
	var newL = "\r\n";
	var sep = "--";
	var startB = newL + sep + boundary + newL;			
	var endB = sep + boundary + sep + newL;
	
	// used to capture the header
	var headerBodySplitterRegx = new RegExp(newL + newL);
	var headerRegx= new RegExp(newL + "\s*([^\r]*)\s*", "mg");
	var headerPartsRegx = /\s*([^:]*):\s*(.+)/;
	
	// used to find the boundary
	var boundaryRegx = /boundary\s*=\s*\"?([^\"]*)\"?/;
	
	var partHandler = function(partArgs, responsePart, ioArgs) {
		// use a try-catch so any errors in callback execution don't
		// kill the processing of other parts... this behaves as
		// if each part were a separate request with its own async
		// callback
		try {
			if(responsePart instanceof Error) {
				if (partArgs.error) {
					partArgs.error(responsePart, ioArgs);
				}
			}
			else {
				try {
					if (partArgs.load) {
						partArgs.load(responsePart, ioArgs);
					}
				}
				catch(err) {
					if (partArgs.error) {
						partArgs.error(err, ioArgs);
					}
				}
			}
			// always call the handle function if it exists
			if (partArgs.handle) {
				partArgs.handle(responsePart, ioArgs);
			}
		} catch(err2) {}
	};
	
	function xhrMime() {
		this.respHeaders = [];
		this.responseText = "";
		this.responseXML = null;
		this.status = 0;
		this.statusText = "";
		this.readyState = 0;
		this.onreadystatechange = function(){};
	}
	
	dojo.extend(xhrMime, {
		getResponseHeader: function(key) {
			key = key.toLowerCase();
			for(var i = 0, header, l = this.respHeaders.length;i < l; i++) {
                header = this.respHeaders[i];
				if (header[0].toLowerCase() == key) {
					return header[1];
				}
			}
			return null;
		},
		getAllResponseHeaders: function() {
			var str = "";
			for(var i = 0, header,l = this.respHeaders.length; i < l; i++) {
                header = this.respHeaders[i];
				str += header[0] + ": " + header[1];
				if(i < l - 1) {
					str += "\n";
				}
			}
			return str;
		},
		send: function(){},
		open: function(){},
		abort: function(){},
		setRequestHeader: function(){}
	});
	
	var unfoldHeaders = function(headerSection) {
		return headerSection.replace(/\r\n\s/mg, " ");
	};
	
	var defaultContentHandler = function(partArgs, partXhr) {
		var xmlPart = null;
		if(partArgs.handleAs == "xml") {
			// create document object from text string
			try {
				xmlPart = com.ibm.domUtilities.docFromString(partXhr.responseText);
			} catch(err) {}
		}
		partXhr.responseXML = xmlPart;
		// call the appropriate content handler for this part
        // dojo.contentHandlers is public since Dojo 1.4
        var djCh = dojo.contentHandlers ? "contentHandlers" : "_contentHandlers";
		return dojo[djCh][partArgs.handleAs](partXhr);
	};

	dojo.mixin(com.ibm.utilities, {
		handleMultiPartResponse: function(parts, response, ioArgs) {
			// Getting the Content-Type header from the response, and extract
			// the boundary string
			var boundMatch = ioArgs.xhr.getResponseHeader("Content-Type").match(boundaryRegx);
			if (!boundMatch) {
				throw new Error("No boundary specified in Content-Type response header");
			}
			var bound = boundMatch[1];
			// build a regx from the response boundary string used to split the parts
			var splitterRegx = new RegExp(newL + sep + bound, "mg");
			
			var respParts = response.split(splitterRegx);
			
			// if handleAs is xml, it comes as text so build it using the domUtilities
			
			// iterate through the response parts, handling the callbacks for each
			for(var i = 1, j = i - 1; i < respParts.length - 1; i++, j++) {
				var partXhr = new xhrMime(),
					part = respParts[i],
					header = null;
				headerRegx.lastIndex = 0;
				
				var partSections = part.split(headerBodySplitterRegx);
				var headerSection = unfoldHeaders(partSections[0]),
					bodySection = partSections[1];
				
				if (!bodySection) {
					bodySection = "";
				}
				
				// extract the headers for this part, stopping at the blank line
				while((header= headerRegx.exec(headerSection)) !== null && (header[1].length > 0)) {
					var headerParts = header[1].match(headerPartsRegx);
					if(headerParts)	{
						partXhr.respHeaders.push([headerParts[1],headerParts[2]]);
					}
				}
				
				part = dojo.string.trim(bodySection);
				partXhr.responseText = part;
				
				if(ioArgs.args.partContentHandler) {
					part = ioArgs.args.partContentHandler(parts[j], partXhr, defaultContentHandler);
				}
				else {
					part = defaultContentHandler(parts[j], partXhr);
				}
				
				partHandler(parts[j], part, dojo.mixin({}, ioArgs, {xhr: partXhr}));
			}
		},
		
		multiPartXhr: function( /*String*/ method, /*dojo.__XhrArgs*/ args, /*Array*/ parts) {
			// summary: Sends a request with a multi-part body (and content type) to
			//		the server.  Uses dojo.xhr functions under the covers, so the args
			//		object has the same structure as what those functions expect.
			//		The main difference is that this function builds the raw post or put
			//		data automatically from the parts array.  Each item in the parts array
			//		is an object which is a subset of the dojo.__XhrArgs type.  The callbacks
			//		should be specified per part as this function will provide a general
			//		callback that parses the multi-part response and calls the callback
			//		associated with that response part provided in the parts array.
			// method: String specifying the HTTP method used.  Must be either POST or PUT.
			//		Default is POST.
			// args: dojo.__XhrArgs specifying how this XHR should be handled.  The following
			//		properties are not used since they do not make sense in this context -
			//			[form, handle, load, content, handleAs]
			//		The following are new args that are available for sending multiPart requests.
			//		{
			//			partContentHandler: function(partArgs, partXhr, defaultContentHandler){} optional 
			// 				function to handle response parts after they've been split and parsed enabling a 
			// 				caller to modify the part response body or the XHR mime associated with the part, 
			// 				returns the response associated with this part in some format, potentially modified
			//				by this handler function
			//			preHandle: function(response, ioArgs){} callback called before the parts
			//				callbacks are called
			//			postHandle: function(response, ioArgs){} callback called after the parts
			//				callbacks have been called
			//
			//		}
			// parts: Array the multiple parts to use to build the multi-part request body.
			//		Each item in the array should be an object with these properties -
			//			{
			//				headers: Object key-value map which is used to write out a
			//					section at the top of this part in the form key: value.
			//					Example could be Content-Type of this part of the multi-part
			//					request.
			//				data: String text to write out the body of this part
			//				load: function(response, ioArgs){} callback called where
			// 					the response body is the body of the part associated this
			//					request part
			//				error: function(response, ioArgs){} callback called when
			//					a failure occurs either in the transmission or from the
			//					server
			//				handle: function(response, ioArgs){} callback called at the
			//					end of this request with either the response or an error
			//					if one occured
			//				handleAs: String value indicating how the response body of this
			//					part should be handled
			//			}
			// returns: Deferred object which can be used to attach additional callbacks to
			
			var body = "",
				headersStr = null;
			dojo.forEach(parts, function(part){
				part.handleAs = part.handleAs ? part.handleAs.toLowerCase() : "text";
				headersStr = "";
				for(var x in part.headers) {
					headersStr += x + ": " + part.headers[x] + newL;
				}
				body += startB + headersStr + newL;
				if (part.data && part.data.length > 0) {
					body += part.data + newL;
				}
			});
			
			body += endB;
			
			// if method is PUT, leave it be; otherwise set it to POST
			if (method.toUpperCase() != "PUT") {
				method = "POST";
			}
			
			args.headers = dojo.mixin({}, args.headers, {
				"Content-type": 'multipart/mixed; boundary="' + boundary + '"'
			});
			
			var xhrArgs = dojo.mixin({}, args, {
				load: function(response, ioArgs) {
					if (args.preHandle) {
						args.preHandle(response, ioArgs);
					}
					com.ibm.utilities.handleMultiPartResponse(parts, response, ioArgs);
					if (args.postHandle) {
						args.postHandle(response, ioArgs);
					}
				}, 
				error: function(response, ioArgs) {
					if (args.preHandle) {
						args.preHandle(response, ioArgs);
					}
					dojo.forEach(parts, function(part){
						partHandler(part, response, ioArgs, null);
					});
					if (args.error) {
						args.error(response, ioArgs);
					}
					if (args.postHandle) {
						args.postHandle(response, ioArgs);
					}						
				},
				handleAs: "text",
				form: null,
				content: null,
				postData: null,
				putData: null
			});
			
			xhrArgs[method.toLowerCase() + "Data"] = body;
			
			return dojo.xhr(method, xhrArgs, true);
		}
	});
})();

}
